/****************************************************************/
/*								*/
/*	XChess V2.7 Adapter: Curses				*/
/*								*/
/*	(c) 1991 by Marc Laukien				*/
/*								*/
/*	Programmteil:	Zug ausfuehren				*/
/*								*/
/****************************************************************/
#include <../old/usr/include/curses.h>
#include <curses.h>
#include <string.h>
#include "ad.h"

extern	unsigned	sleep();

/****************************************************************/
/*	Zug ausfuehren						*/
/****************************************************************/

void	ad_zug(ch)

char 	ch;				/* Charakter	*/
{
	char	str[STRLEN];		/* String	*/
	int	i;

	strcpy(str,"ziehe ");		/* aufbereiten	*/

	move(16,MPOS);			/* in Position	*/
	addstr(domove);			/* Meldung	*/
	addch(ch|A_UNDERLINE);		/* ausgeben	*/
	sprintf(str+strlen(str),"%c",(char)ch);		/* aufbereiten	*/
	refresh();

l1:	ad_read(0,&ch,1);		/* einlesen	*/
	if(ch=='\b')		/* zurueck ?	*/
	{
		addstr("\b \b");
		str[strlen(str)-1]=0;
		refresh();
		goto l5;
	}
	if(ch<(int)'1' || ch>(int)'8')
	{
		beep();
		goto l1;
	}
	addch(ch|A_UNDERLINE);	/* ausgeben	*/
	sprintf(str+strlen(str),"%c ",(char)ch);	/* aufbereiten	*/
	addch((int)'-'|A_UNDERLINE);
	refresh();
	
l2:	ad_read(0,&ch,1);		/* einlesen	*/
	if(ch=='\b')		/* zurueck ?	*/
	{
		addstr("\b \b");
		str[strlen(str)-1]=0;
		addstr("\b \b");
		str[strlen(str)-1]=0;
		refresh();
		goto l1;
	}
	if(ch<(int)'a' || ch>(int)'h')
	{
		beep();
		goto l2;
	}
	addch(ch|A_UNDERLINE);	/* ausgeben	*/
	sprintf(str+strlen(str),"%c",(char)ch);		/* aufbereiten	*/
	refresh();
	
l3:	ad_read(0,&ch,1);		/* einlesen	*/
	if(ch=='\b')		/* zurueck ?	*/
	{
		addstr("\b \b");
		str[strlen(str)-1]=0;
		refresh();
		goto l2;
	}
	if(ch<(int)'1' || ch>(int)'8')
	{
		beep();
		goto l3;
	}
	addch(ch|A_UNDERLINE);	/* ausgeben	*/
	sprintf(str+strlen(str),"%c",(char)ch);		/* aufbereiten	*/
	refresh();

	schach(str,ptr);	/* ziehen	*/
	if(ptr[0][0]!='?')	/* zug ok ?	*/
	{
		ad_brett();
		farbe= farbe=='w' ? 's':'w';	
				/* naechste Farbe	*/
	}
	else			/* falscheingabe	*/
		beep();

l5:	move(16,MPOS);		/* in Position	*/
	for(i=MPOS;i<79;i++)	/* loschen	*/
		addstr(" ");
	refresh();

	if(TURNGEG())
	{
		ad_lock();
		sprintf(str,"save %s",stdname);
		schach(str,ptr);	/* Speichern		*/
		ad_unlock();
	}
}

/****************************************************************/
/*	externen Zug ausfuehren					*/
/****************************************************************/

void	ad_extzug()
{
	char	s[STRLEN];
	int	i;

	sleep((unsigned)5);	/* warten		*/

	ad_lock();
	sprintf(s,"load %s",stdname);	/* Pfad zum Laden	*/
	schach(s,ptr);		/* Laden		*/
	ad_unlock();

	if(ptr[0][0]=='?')	/* Fehler ?		*/
	{
		move(3,MPOS);

		if(W_IS_USER())		/* Schwarz gab auf	*/
		{
			attrset(0);	/* Alle Attribute aus	*/
			addstr(b_up);	/* Meldung		*/

			ende=S_AUFG;
		}

		if(B_IS_USER())		/* Weiss gab auf	*/
		{
			attrset(0);	/* Alle Attribute aus	*/
			addstr(w_up);	/* Meldung		*/

			ende=W_AUFG;
		}

		for(i=stdscr->_curx;i<79;i++)	/* Rest der Zeile loeschen*/
			mvaddch(stdscr->_cury,i,(int)' ');

	}
	else
	{
		ad_brett();		/* Brett aufbauen	*/

		schach("info",ptr);	/* Info holen		*/
		modus = atoi(ptr[9]);	/* merken		*/
		farbe = ptr[0][0];
		level = atoi(ptr[6]);

		ad_menu();
	}
}
